#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define F first
#define S second
#define ld long double
mt19937 rnd(time(0));

int n;
ld step;
pair<ld, ld> v1, v2;
vector<pair<int, int>> arr;
vector<vector<ld>> dp;


ld dist(pair<int, int> h1, pair<int, int> h2) {
    int x = h2.first - h1.first;
    int y = h2.second - h1.second;
    ld b = (y * v1.F / v1.S - x) / (v2.S * v1.F / v1.S - v2.F);
    ld a = (x - v2.F * b) / v1.F;
    return (abs(a) + abs(b)) * step;
}

ld dist(int a, int b) {
    return dist(arr[a], arr[b]);
}

/*
v1 = {v.F, v.S}
v2 = {v.S, -v.F}

x = v1.F * a + v2.F * b
y = v1.S * a + v2.S * b

y * v1.F / v1.S = v1.F * a + v2.S * b * v1.F / v1.S

(y * v1.F / v1.S - x) / (v2.S * v1.F / v1.S - v2.F) = b

(x - v2.F * b) / v1.F = a
*/

ld f(int pos, int visited) {
    if (dp[pos][visited] != -1.0)
        return dp[pos][visited];

    if (visited == (1 << n) - 1)
        return 0;

    ld ans = 1000000000ll;
    for (int i = 0; i < n; ++i)
        if (!(visited & (1 << i))) {
            ld d = dist(pos, i);
            ans = min(ans, f(i, visited | (1 << i)) + d);
        }

    dp[pos][visited] = ans;
    return ans;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    ld ans = 1000000000000;
    cin >> n;
    arr.resize(n);
    for (auto &p: arr)
        cin >> p.first >> p.second;

    for (int i = 0; i < n; ++i)
        for (int j = i + 1; j < n; ++j) {
            v1 = {arr[j].first - arr[i].first, arr[j].second - arr[i].second};
            v2 = {v1.S, -v1.F};
            step = sqrtl(v1.F * v1.F + v1.S * v1.S);
            dp.assign(n, *new vector<ld>(1 << n, -1.0));
            for (int k = 0; k < n; ++k)
                ans = min(ans, f(k, 1 << k));
        }

    cout << fixed << setprecision(12) << ans;
}
/*
3
1 2
0 1
3 0

4
5 3
1 4
2 6
6 0

2
0 0
5 5

*/
/*

*/
/*

*/